> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mangopay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Refunds for a Transfer

### Query parameters

<ParamField query="Status" type="string">
  **Allowed values:** `CREATED`, `SUCCEEDED`, `FAILED`

  The status of the transaction. You can filter on multiple values by separating them with a comma.
</ParamField>

<ParamField query="ResultCode" type="string">
  The code indicating the result of the operation. You can filter on multiple values by separating them with a comma.
</ParamField>

<ParamField query="BeforeDate" type="Unix timestamp">
  The date before which the transaction was created (based on the transaction’s `CreationDate` parameter). You can filter on a specific time range by using both the `AfterDate` and `BeforeDate` query parameters.
</ParamField>

<ParamField query="AfterDate" type="Unix timestamp">
  The date after which the transaction was created (based on the transaction’s `CreationDate` parameter). You can filter on a specific time range by using both the `AfterDate` and `BeforeDate` query parameters.
</ParamField>

### Path parameters

<ParamField path="TransferId" type="string" required>
  The unique identifier of the transfer.
</ParamField>

### Responses

<AccordionGroup>
  <Accordion title="200">
    <ResponseField name="Array (Refunds)" type="array">
      The list of refunds created by the platform.

      <Expandable title="properties">
        <ResponseField name="Object (Refund)" type="object">
          The refund created by the platform.

          <Expandable title="properties">
            <ResponseField name="Id" type="string">
              Max length: 128 characters (see [data formats](/api-reference/overview/data-formats) for details)

              The unique identifier of the object.
            </ResponseField>

            <ResponseField name="Tag" type="string">
              Max. length: 255 characters

              Custom data that you can add to this object.\
              For transactions (pay-in, transfer, payout), you can use this parameter to identify corresponding information regarding the user, transaction, or payment methods on your platform.
            </ResponseField>

            <ResponseField name="CreationDate" type="Unix timestamp">
              The date and time at which the object was created.
            </ResponseField>

            <ResponseField name="AuthorId" type="string">
              The unique identifier of the user at the source of the initial transaction.
            </ResponseField>

            <ResponseField name="CreditedUserId" type="string">
              **Default value:** The unique identifier of the owner of the credited wallet.

              The unique identifier of the user whose wallet is credited.
            </ResponseField>

            <ResponseField name="DebitedFunds" type="object">
              **Default value:** The amount and currency values of the debited funds of the initial transaction.

              Information about the debited funds. Debited funds:

              * Takes by default the amount and currency values of the initial transaction when left empty.
              * Must be entered manually to perform a partial refund.
              * Cannot exceed the initial transaction `CreditedFunds` value when entered manually. This also applies to the sum of debited funds when making multiple partial refunds.

              <Expandable title="properties">
                <ResponseField name="Amount" type="integer">
                  An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
                </ResponseField>

                <ResponseField name="Currency" type="string">
                  **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

                  The currency of the debited funds.
                </ResponseField>
              </Expandable>
            </ResponseField>

            <ResponseField name="Fees" type="object">
              **Default value:** The amount and currency values of the fees of the initial transaction.

              Information about the fees. This value:

              * Should be preceded by a minus sign (-) to refund the fees, otherwise more fees will be taken.
              * Takes by default the amount and currency values of the fees of the initial transaction when left empty (preceded by a -).
              * Cannot exceed the initial transaction fees amount when entered manually. This also applies to the sum of the amount of the fees when making multiple partial refunds.

              <Expandable title="properties">
                <ResponseField name="Amount" type="integer">
                  An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
                </ResponseField>

                <ResponseField name="Currency" type="string">
                  **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

                  The currency of the debited funds.
                </ResponseField>
              </Expandable>
            </ResponseField>

            <ResponseField name="Status" type="string">
              **Returned values:** `CREATED`, `SUCCEEDED`, `FAILED`

              The status of the transaction.
            </ResponseField>

            <ResponseField name="ResultCode" type="string">
              The code indicating the result of the operation. This information is mostly used to <a href="/errors/codes">handle errors</a> or for filtering purposes.
            </ResponseField>

            <ResponseField name="ResultMessage" type="string">
              The explanation of the result code.
            </ResponseField>

            <ResponseField name="ExecutionDate" type="Unix timestamp">
              The date and time at which the status changed to `SUCCEEDED`, indicating that the transaction occurred. The statuses `CREATED` and `FAILED` return an `ExecutionDate` of `null`.
            </ResponseField>

            <ResponseField name="Type" type="string">
              **Returned values:** `PAYIN`, `TRANSFER`, `CONVERSION`, `PAYOUT`

              The type of the transaction.
            </ResponseField>

            <ResponseField name="Nature" type="string">
              **Returned values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT`

              The nature of the transaction, providing more information about the context in which the transaction occurred:

              * `REGULAR` – Relative to most of the transactions (pay-ins, payouts, and transfers) in a usual workflow.
              * `REPUDIATION` – Automatic withdrawal of funds from the platform’s repudiation wallet as part of the dispute process (when the user has requested a chargeback).
              * `REFUND` – Reimbursement of a transaction to the user (pay-in refund), to a wallet (transfer refund), or of a payout (payout refund, only initiated by Mangopay).
              * `SETTLEMENT` – Transfer made to the repudiation wallet by the platform to settle a lost dispute.
            </ResponseField>

            <ResponseField name="DebitedWalletId" type="string">
              The unique identifier of the debited wallet.
            </ResponseField>

            <ResponseField name="CreditedWalletId" type="string">
              The unique identifier of the credited wallet.
            </ResponseField>
          </Expandable>
        </ResponseField>
      </Expandable>
    </ResponseField>
  </Accordion>
</AccordionGroup>

<ResponseExample>
  ```json 200 theme={null}
  [
      {
          "Id": "refund_m_01JJ264GDXH7QAW558VMKBCE2M",
          "Tag": "Partial refund with fees refunded",
          "CreationDate": 1737387819,
          "AuthorId": "user_m_01JHSSTVRDN5SN9T14SRC6SA9A",
          "CreditedUserId": null,
          "DebitedFunds": {
              "Currency": "EUR",
              "Amount": 1782
          },
          "CreditedFunds": {
              "Currency": "EUR",
              "Amount": 2454
          },
          "Fees": {
              "Currency": "EUR",
              "Amount": -672
          },
          "Status": "SUCCEEDED",
          "ResultCode": "000000",
          "ResultMessage": "Success",
          "ExecutionDate": 1737387819,
          "Type": "TRANSFER",
          "Nature": "REFUND",
          "CreditedWalletId": "wlt_m_01JHSSTYGT28P1F5KJ82QZ0K65",
          "DebitedWalletId": "wlt_m_01JJ25YQA60D8FVZYEBMXG733F"
      },
      {
          "Id": "refund_m_01JJ264WWWPCM1WPS3TG08G0Y2",
          "Tag": "Partial refund with more fees taken",
          "CreationDate": 1737387832,
          "AuthorId": "user_m_01JHSSTVRDN5SN9T14SRC6SA9A",
          "CreditedUserId": null,
          "DebitedFunds": {
              "Currency": "EUR",
              "Amount": 1672
          },
          "CreditedFunds": {
              "Currency": "EUR",
              "Amount": 1183
          },
          "Fees": {
              "Currency": "EUR",
              "Amount": 489
          },
          "Status": "SUCCEEDED",
          "ResultCode": "000000",
          "ResultMessage": "Success",
          "ExecutionDate": 1737387832,
          "Type": "TRANSFER",
          "Nature": "REFUND",
          "CreditedWalletId": "wlt_m_01JHSSTYGT28P1F5KJ82QZ0K65",
          "DebitedWalletId": "wlt_m_01JJ25YQA60D8FVZYEBMXG733F"
      }
  ]
  ```
</ResponseExample>

<RequestExample>
  ```json REST theme={null}
  // GET has no body parameters
  ```

  ```php PHP theme={null}
  <?php 

  require_once 'vendor/autoload.php';

  use MangoPay\MangoPayApi;
  use MangoPay\Libraries\ResponseException as MGPResponseException;
  use MangoPay\Libraries\Exception as MGPException;

  $api = new MangoPayApi();

  $api->Config->ClientId = 'your-client-id';
  $api->Config->ClientPassword = 'your-api-key';
  $api->Config->TemporaryFolder = 'tmp/';

  try {
      $transferId = '155585643';

      $response = $api->Transfers->GetRefunds($transferId);

      print_r($response);
  } catch(MGPResponseException $e) {
      print_r($e);
  } catch(MGPException $e) {
      print_r($e);
  }  
  ```

  ```javascript NodeJS   theme={null}
  const mangopayInstance = require('mangopay4-nodejs-sdk')
  const mangopay = new mangopayInstance({
    clientId: 'your-client-id',
    clientApiKey: 'your-api-key',
  })

  let myTransfer = {
    Id: '180974208',
  }

  const listRefunds = async (transferId) => {
    return await mangopay.Transfers.getRefunds(transferId)
      .then((response) => {
        console.info(response)
        return response
      })
      .catch((err) => {
        console.log(err)
        return false
      })
  }

  listRefunds(myTransfer.Id)  
  ```

  ```ruby Ruby   theme={null}
  require 'mangopay'

  MangoPay.configure do |client|
      client.preproduction = true
      client.client_id = 'your-client-id'
      client.client_apiKey = 'your-api-key'
      client.log_file = File.join(Dir.pwd, 'mangopay.log')
  end

  def listTransferRefunds(transferId)
      begin
          response = MangoPay::Transfer.refunds(transferId)
          puts response
          return response
      rescue MangoPay::ResponseError => error
          puts "Failed to fetch refunds: #{error.message}"
          puts "Error details: #{error.details}"
          return false
      end
  end

  myTransfer = {
      Id: '180974208'
  }

  listTransferRefunds(myTransfer[:Id])  
  ```

  ```java Java theme={null}
  import com.google.gson.Gson;
  import com.google.gson.GsonBuilder;
  import com.mangopay.MangoPayApi;
  import com.mangopay.entities.Refund;
  import java.util.List;

  public class ListTransferRefunds {
      public static void main(String[] args) throws Exception {
          MangoPayApi mangopay = new MangoPayApi();
          mangopay.getConfig().setClientId("your-client-id");
          mangopay.getConfig().setClientPassword("your-api-key");

          var transferId = "xfer_m_01J1WJCSBG0S4637BR54YYJX0Z";

          List<Refund> refunds = mangopay.getTransferApi().getRefunds(transferId);

          for (Refund refund : refunds) {
              Gson prettyPrint = new GsonBuilder().setPrettyPrinting().create();
              String prettyJson = prettyPrint.toJson(refund);

              System.out.println(prettyJson);
          }
      }
  }
  ```

  ```python Python   theme={null}
  from pprint import pprint
  import mangopay

  mangopay.client_id='your-client-id'
  mangopay.apikey='your-api-key'

  from mangopay.resources import LegalUser, Transfer, TransferRefund

  legal_user = LegalUser.get('211918806')

  legal_user_wallet_id = '213754077'

  transfer = Transfer.get('214568995')

  transfer_refund = TransferRefund(
      id = transfer.id,
      author = legal_user,
      transfer = transfer
  )

  transfer_refunds = Transfer.get_refunds(self = transfer_refund)

  for transfer_refund in transfer_refunds:
      pprint(vars(transfer_refund))  
  ```

  ```csharp .NET  theme={null}
  using MangoPay.SDK;
  using MangoPay.SDK.Entities;
  using Newtonsoft.Json;

  class Program
  {
      static async Task Main(string[] args)
      {
          MangoPayApi api = new MangoPayApi();

          api.Config.ClientId = "your-client-id";
          api.Config.ClientPassword = "your-api-key";

          var transferId = "xfer_m_01J3ZG49W215VVZRJS394DKM00";

          var viewTransferRefunds = await api.Refunds.GetRefundsForTransferAsync(transferId, new Pagination(1, 100), null);

          string prettyPrint = JsonConvert.SerializeObject(viewTransferRefunds, Formatting.Indented);
          Console.WriteLine(prettyPrint);
      }
  }
  ```
</RequestExample>
